import java.awt.image.BufferedImage;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.Iterator;
import java.util.Set;

/**
 * @author Your name and UWNetID go here.
 *
 * IndexedColor Encoder is a helper class for ImageAnalyzer.
 * It is where the methods for palette building and image encoding will be
 * implemented.
 * 
 * Students: Implement code wherever you see "TODO".
 */
public class IndexedColorEncoder {
	public static CustomHashtables customHashtables; // Your own hash table facility.
	CustomHashtables.SeparateChainingHashtable<Block, Integer> H ;
	CustomHashtables.SeparateChainingHashtable<Block, Integer> tht1;

	public Color[][] colorImg;
	public ArrayList<Block> sortedBlocks; // to store sorted blocks(list L)
	public Color[] palette;	// stores the first U elements of list L
	public int[][] encodedPixels;	// to store the value each pixel in the image is encoded to.
	int blockSize; // Controls how much colors are grouped during palette building.
	int hashFunctionChoice; // Either 1, 2, or 3. Controls whether to use h1, h2, or h3.
	ImageAnalyzer theMainApp;
	int w, h; // width and height of current image.
	ArrayList<BlockCountPair> L; // Used when building a palette and encoding pixels.
	public double error; // To hold the per-pixel lossy encoding error.

	/* Constructor sets up a link back to the application, so that parts of
	 * the GUI and the working image can be accessed from this class.
	 */
	public IndexedColorEncoder(ImageAnalyzer theMainApp) {
		this.theMainApp = theMainApp;
		customHashtables = new CustomHashtables(); // Getting ready for your own hash table.
		hashFunctionChoice = 1; // Default hash function number is 1.
		blockSize = 4; // Default blockSize is 4x4x4

	}
	public void setHashFunctionChoice(int hc) {
		hashFunctionChoice = hc;
		System.out.println("Hash function choice is now "+hashFunctionChoice);
	}

	public void setBlockSize(int bs) {
		blockSize = bs;
		System.out.println("Block size is now "+blockSize);
	}
	class BlockCountPair {
		Block b; Integer count;
		public BlockCountPair(Block b, Integer count) {
			this.b = b; this.count = count;
		}
	}

	public void buildPalette(int paletteSize) {
		// Get the image we will be processing.
		BufferedImage I = theMainApp.biWorking;
		// Convert it to a 2-D array of Color objects.
		colorImg = theMainApp.storeCurrentPixels(I);
		// cache the width and height of this image:
		w = I.getWidth(); h = I.getHeight();

		//Set up a hash table for our blocks (the keys) and their counts (the values).
        H = customHashtables.new SeparateChainingHashtable<Block, Integer>(13, 2.0);  // TODO Change tableSize and rehashingThreshold if you need to.

		// Now we develop our implementation based on the pseudocode from Part I of the Assignment.

		//We scan through all the pixels of the source image I and for each pixel p:
		for (int row=0; row<I.getHeight(); row++) {
			for (int col=0; col<I.getWidth(); col++) {

			//TODO  Implement the instantiation of Color and Block objects and hash them,
				// counting occurrences of blocks.
			}
			System.out.print(".");
		}
		//By this point, we have a hash table full of blocks and their counts.
		//Next we make a list L of the blocks and their counts by getting all of the pairs out of the hash table.

		// THIS PART OF THE ALGORITHM IS DONE FOR YOU:
		Set<Block> keys = H.keySet();
		L = new ArrayList<BlockCountPair>();
		Iterator<Block> ib = keys.iterator();
		while (ib.hasNext()) {
			Block b = ib.next();
			L.add(new BlockCountPair(b, (Integer)(H.getAndMore(b)).val));
		}
		// Now sort L by the weight values, so that the w values are in nonincreasing order. 
		// The largest is first.

		Collections.sort(L, new Comparator<BlockCountPair> (){
			public int compare(BlockCountPair b1, BlockCountPair b2) {
				return b2.count - b1.count; // Note the reverse order.
			}
		});
		//Assuming the palette should have U entries, choose the first U elements of L, and call this LU.
		int U = paletteSize;
		Color[] T = new Color[U]; // create an empty color table T.
		int s = blockSize;
		//System.out.println("Color table T has these entries:");
		
		// TODO  You write the loop that computes the representative color for each block
		// and puts it into the palette.
		// Optionally print out these color objects as you go.
		
		palette = T; // save the palette

		// Now enable encoding:
		theMainApp.encodeSSItem.setEnabled(true);
		theMainApp.encodeFItem.setEnabled(true);
		// If using a small image, optionally show the hash table, for debugging:
		//System.out.println(H);
		// This assumes you have written a toString method for your hash table that
		// makes a nice display of the contents of the table.
	}

	public void encodeSlowAndSimple() {
		ImageAnalyzer.ElapsedTime essTime = theMainApp.new ElapsedTime();
		essTime.startTiming();
	
		// Allocate a buffer for the new image.
		encodedPixels = new int[h][w] ;	// to store the value each pixel in the image is encoded to.
		// Scan the Color version of the original image.
		for (int i=0; i<h; i++) {
			for (int j=0; j<w; j++) {
				Color c = colorImg[i][j];

				// TODO You write the code that determines the best index for this color.
				
				// TODO You write the cod that stores the result into the encoded pixels array.
			}
		}
		essTime.reportTime(); 
		System.out.println("Encoding with the slow-and-simple method is complete. Try decoding to see how much information was lost.");
		theMainApp.decodeItem.setEnabled(true);

	}

	public void encodeFast() {  
		ImageAnalyzer.ElapsedTime efTime = theMainApp.new ElapsedTime();
		efTime.startTiming();
		// Loop through the elements of L.
		Iterator LIter = L.iterator();
		int s = blockSize;
		while (LIter.hasNext()) {

			// TODO You write the body of this loop, where we
			// get the BlockCountPair object from the list and
			// compute the representative color of the block:
			
			// TODO
			// Find index of closest color in the table:

			// In the hashtable, replace the entry (b, w) by (b, idx):
			// TODO

		}
		// Now scan the source image.
		encodedPixels = new int[h][w] ;	// to store the value each pixel in the image is encoded to.
		// Scan the Color version of the original image.
		for (int i=0; i<h; i++) {
			for (int j=0; j<w; j++) {
				Color c = colorImg[i][j];

				// TODO
				// You write the code to convert the color to a block and
				// use the block to look up the representative color index int
				// the hash table.
				// This the main difference from the slow method. We use hashing here!

				// Now store that index in the encodedPixels array.
				// TODO
			}
		}
		efTime.reportTime(); 
		System.out.println("Encoding with the fast method is complete. Try decoding to see how much information was lost.");
		theMainApp.decodeItem.setEnabled(true);
	}

	public class Color {
		int r, g, b;

		Color(int r, int g, int b) {
			this.r = r; this.g = g; this.b = b;    		
		}
		
		public int toInt() {
			return (((r<<8) + g) << 8)+r;
		}
		
		public String toString() {
			return "("+r+","+g+","+b+")";
		}

		double euclideanDistance(Color c2) {
			// TODO
			// Replace this to return the distance between this color and c2.
			if (c2==null) { return Double.MAX_VALUE; }
			int dr = r-c2.r;
			int dg = g-c2.g;
			int db = b-c2.b;
			int sum_sq = dr*dr + dg*dg + db*db;
			return Math.sqrt(sum_sq);
		}
		int findIndexOfClosestColor(Color[] palette){
			double dist_so_far = 256.0 * 2; // something greater than 255 * cube root of 3.
			int best_index_so_far = 0;
			for (int i=0; i<palette.length; i++) {
				double this_distance = euclideanDistance(palette[i]);
				if (this_distance < dist_so_far) {
					dist_so_far = this_distance;
					best_index_so_far = i;
				}
			}
			return best_index_so_far;
		}
	}


	public class Block extends Object {
		// TODO
		// Implement your block methods here.  hashCode is done for you, but you still need to write
		// the bodies for h1, h2, and h3 near the end of this file.
		// Include necessary fields, constructor and 
		// Remember to override the equals method.

		int Br, Bg, Bb; // ADDED BY SLT.
		public Block(int Br, int Bg, int Bb) {
			this.Br = Br; this.Bg = Bg; this.Bb = Bb;
		}
		public Block(Color c) {
			Br = c.r / blockSize; Bg = c.g / blockSize; Bb = c.b / blockSize;
		}

		public int hashCode() {
			if (hashFunctionChoice == 1) {
				return h1(this);
			} else if (hashFunctionChoice == 2) {
				return h2(this);
			} else if (hashFunctionChoice == 3) {
				return h3(this);
			} else {
				return -1; // This should never happen.
			}
		}
		@Override
		public boolean equals(Object o2) {
			Block b2 = (Block)o2;
			boolean result = false;
			// TODO Compute the result.
			return result;
		}
		public String toString() {
			return "("+Br+","+Bg+","+Bb+")";
		}
	}

	public int h1(Block b) {
		return 0;  // TODO Fix this.
	}

	public int h2(Block b) {
		return 0;  // TODO Fix this.
	}

	public int h3(Block b) {
		// TODO
		// Replace this with your code for your own hash function.
		return 0;
	}

/*
 * The decode method is done for you.
 * Once you have either of the encoding methods working, you'll be able to run
 * this one from the menu and see how the image looks after compression.
 */
public void decode() {
	// Scan through the encodedPixels and look up each one's color, and put it into the image buffer.
	for (int i=0; i<h; i++ ) {
		for (int j=0; j<w; j++) {
			int pixelsColorIndex = encodedPixels[i][j];
			Color c = palette[pixelsColorIndex];
		    theMainApp.putPixel(theMainApp.biWorking, i, j, c);
			
		}
	}
	theMainApp.repaint();
	error = theMainApp.computeError(colorImg, theMainApp.biWorking);
	System.out.println("Average per-pixel error: "+error);

}
}
